<?php
/*
 * Plugin Name: CoolIris-Piclens
 * Version: 0.3.2
 * Description: Cooliris/Piclens activation
 * Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=234
 * Author: Tiico
 * Author URI: 
 * */
/********* Fichier piclens-class.php  *********/
 

class Piclens
{
    var $my_config;
	// Add Piclens CSS & Javascript in HEAD section
	function piclens_link()
	{
	    global $template, $page, $user;

		$jscript = '<script type="text/javascript"> function roll_over_piclens(img_name, img_src){document[img_name].src = img_src;}</script>';
		$template->append('head_elements',$jscript);			
	    
		// Vrification d'activation du plugin (page administration)
		if ($this->my_config['piclens_active'])
		{
			if (isset($page['section']))
			{
				// Page images recentes
				if (($page['section']) == 'recent_pics' && $this->my_config['piclens_recentpics_active'])
				{
					$piclnkMaster='<link rel="alternate"'
								. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/recent_pics"'
								.' type="application/rss+xml" title="" id="recent_pics"'
								. ' >' . "\n";			
				}
				// Page categories recentes
				elseif (($page['section']) == 'recent_cats' && $this->my_config['piclens_recentcats_active'])
				{
					if ($this->my_config['piclens_recursive_mode'] != 'standard')
					{
						$query = 'SELECT c.id, c.permalink
						  FROM '.CATEGORIES_TABLE.' c INNER JOIN '.USER_CACHE_CATEGORIES_TABLE.'
						  ON id = cat_id and user_id = '.$user['id'].'
						  WHERE date_last >= SUBDATE(
							CURRENT_DATE,INTERVAL '.$user['recent_period'].' DAY
						  )
						'.get_sql_condition_FandF
						  (
							array
							  (
								'visible_categories' => 'id',
							  ),
							'AND'
						  ).'
						;';
						$piclnkMaster='';
						$result = pwg_query($query);
						while ($row = mysql_fetch_assoc($result))
						{
							// Gestion des permalinks
							$categoryId = $row['id'] ;
							if (!empty($row['permalink']))
								$categoryId = $row['permalink'];
					
							$piclnkMaster.='<link rel="alternate"'
										. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
										. $categoryId .'&norecurs"'
										.' type="application/rss+xml" title="" id="'.$row['id'].'"'
										. ' >' . "\n";
							
						}
					}
					else
					{

						$piclnkMaster='<link rel="alternate"'
									. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/recent_cats"'
									.' type="application/rss+xml" title="" id="recent_cats"'
									. ' >' . "\n";			

					}
				}
				// Page plus vues
				elseif (($page['section']) == 'most_visited' && $this->my_config['piclens_mostvisited_active'])
				{
					$piclnkMaster='<link rel="alternate"'
								. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/most_visited"'
								.' type="application/rss+xml" title="" id="most_visited"'
								. ' >' . "\n";			
				}
				// mieux notees	
				else if ($page['section'] == 'best_rated' && $this->my_config['piclens_bestrated_active'])
				{
					$piclnkMaster='<link rel="alternate"'
								. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/best_rated"'
								.' type="application/rss+xml" title="" id="best_rated"'
								. ' >' . "\n";			
				}
				// favories	
				else if ($page['section'] == 'favorites' && $this->my_config['piclens_favorites_active'])
				{
					$piclnkMaster='<link rel="alternate"'
								. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/favorites"'
								.' type="application/rss+xml" title="" id="favorites"'
								. ' >' . "\n";			
				}

				// Seulement sur une page type 'categorie'
				elseif (($page['section']) == 'categories')
				{			
					// Page accueil et option gallerie activee
				    if( (empty($page['category'])) && $this->my_config['piclens_gallerie_active'] )
				    {
						if ($this->my_config['piclens_recursive_mode'] != 'standard')
						{
							$query = 'SELECT id,name,permalink FROM ' . CATEGORIES_TABLE
							.' WHERE id_uppercat is NULL';
							
							$piclnkMaster='';
							$result = pwg_query($query);

							while ($row = mysql_fetch_assoc($result))
							{
								if (!(in_array($row['id'], explode(',', $user['forbidden_categories']))))
								{
									$piclnkMaster.='<link rel="alternate"'
												. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
												. $row['id'] .'"'
												.' type="application/rss+xml" title="" id="'.$row['id'].'"'
												. ' >' . "\n";										
								}
							}
						
						}
						else
						{
							$piclnkMaster='<link rel="alternate"'
										. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/categories"'
										.' type="application/rss+xml" title="" id="accueil"'
										. ' >' . "\n";
						}
				    }
					// Add only if we are in category page
				    elseif (!empty($page['category']['id']))
					{

						if ($this->my_config['piclens_recursive_mode'] != 'standard')
						{
							$categoryId = $page['category']['id'] ;
							if (!empty($page['category']['permalink']))
								$categoryId = $page['category']['permalink'];

							$piclnkMaster='<link rel="alternate"'
										. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
										. $categoryId .'&norecurs"'
										.' type="application/rss+xml" title="" id="'.$page['category']['id'].'"'
										. ' >' . "\n";

							$query = '
							SELECT DISTINCT(id)
							FROM '.CATEGORIES_TABLE.'
							WHERE id_uppercat='.$page['category']['id'].';';
							$result = pwg_query($query);

							while ($row = mysql_fetch_array($result))
							{
								$piclnkMaster.='<link rel="alternate"'
											. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
											. $row['id'] .'"'
											.' type="application/rss+xml" title="" id="'.$row['id'].'"'
											. ' >' . "\n";
							}
/*							
							$piclnkMaster.='<link rel="alternate"'
										. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
										. $categoryId .'&norecurs"'
										.' type="application/rss+xml" title="" id="'.$page['category']['id'].'"'
										. ' >' . "\n";
*/
						}
						
						else
						{
							// Gestion des permalinks
							$categoryId = $page['category']['id'] ;
							if (!empty($page['category']['permalink']))
								$categoryId = $page['category']['permalink'];
					
							$piclnkMaster='<link rel="alternate"'
										. ' href="'.get_root_url().PICLENS_PATH.'piclens-rss.php?/category/'
										. $categoryId .'"'
										.' type="application/rss+xml" title="" id="'.$page['category']['id'].'"'
										. ' >' . "\n";
						}
					}
				}
				
				if (isset($piclnkMaster))
				{
					$piclnk=$piclnkMaster;
					// We need absolute path
					set_make_full_url();
				
					 $template->append('head_elements',$piclnk.'<script type="text/javascript" src="http://lite.piclens.com/current/piclens.js"></script>');			
				}
			}
	    }
	}


	// Add piclens Flash slideshow to toolbar
	// Thanks to P@t
	function add_piclens_icon()
	{
		global $template, $page;
		if ($this->my_config['piclens_lite_active'] && $this->my_config['piclens_active'])
		{
	 		// Seulement sur une page type 'categorie'
			if (isset($page['section']))
			{
				// images recentes
				
				if (   (($page['section']) == 'recent_pics' && $this->my_config['piclens_recentpics_active'])
					|| (($page['section']) == 'recent_cats' && $this->my_config['piclens_recentcats_active'])
					|| (($page['section']) == 'most_visited' && $this->my_config['piclens_mostvisited_active'])
					|| (($page['section']) == 'best_rated' && $this->my_config['piclens_bestrated_active'])
					|| (($page['section']) == 'favorites' && $this->my_config['piclens_favorites_active'])
					|| (($page['section']) == 'categories')
					)
				// categories recentes
				// plus vues
				// mieux notees	
				// favories	
				{
					if($page['section'] == 'categories')
					{
						if (empty($page['category']))	// 	acceuil
							$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/categories';
						else
						{
							$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/category/';
							$rssfeed .= empty($page['category']['permalink']) ? $page['category']['id'] : $page['category']['permalink'];
						}
					}
					$tpl_code = '<li><a href="javascript:PicLensLite.start('.(isset($rssfeed) ? ' {feedUrl:\''.$rssfeed.'\'}' : '').');" title="'.l10n('piclens_button').'" onmouseover="roll_over_piclens(\'but1\', \''.get_root_url().PICLENS_IMG_PATH.'cooliris-icon-point.png\')" onmouseout="roll_over_piclens(\'but1\', \''.get_root_url().PICLENS_IMG_PATH.'cooliris-icon.png\')">';
					$tpl_code.='<img src="'.get_root_url().PICLENS_IMG_PATH.'cooliris-icon.png" NAME="but1" class="button" alt="'.l10n('piclens_button').'" width="24" height="24"></a></li>';
					if(($page['section'] == 'categories') && empty($page['category']) && !$this->my_config['piclens_gallerie_active'])	// Accueil et option piclens gallerie desactivee
						$tpl_code='<img src="'.get_root_url().PICLENS_IMG_PATH.'cooliris-icon-black.png" NAME="but1" class="button" alt="'.l10n('piclens_button').'" width="24" height="24"></a></li>';
				}
				if (isset($tpl_code))
					$template->concat('PLUGIN_INDEX_ACTIONS', $tpl_code);
			}
		}
	}


	// Add piclens pics to start slideshow
	// Another thanks to P@t
	function set_make_full_url_piclens()
	{
		set_make_full_url();
	}

	/* Loading of the configuration file - If not exist -> load default values */
	function load_config()
	{
		// changement du nom du fichier de conf.
		if (!file_exists(PICLENS_CFG_FILE))
		{
			if (file_exists(PICLENS_CFG_FILE_OLD))
				@rename(PICLENS_CFG_FILE_OLD,PICLENS_CFG_FILE);
		}
		
		$x = @file_get_contents( PICLENS_CFG_FILE );
		if ($x!==false)
		{
		  $c = unserialize($x);
		  $this->my_config = $c;
		}
		// Init default value for the config file
		$this->load_default_config();
		
		// Desactivation de piclenswall si PWG Stuff est installe
		$this->my_config['piclens_wall'] = (get_db_plugins('active','PWG_Stuffs') ? false : $this->my_config['piclens_wall']);

		// Si tri = defaut PIWIGO ==> l'ordre est egalement defaut PIWIGO
		if ($this->my_config['piclens_order'] == 1)			$this->my_config['piclens_sort'] = 1;
		if ($this->my_config['piclens_order_cat'] == 1)		$this->my_config['piclens_sort_cat'] = 1;
	}

	/* Saving of the configuration file with data */
	function save_config()
	{
		$file = fopen( PICLENS_CFG_FILE, 'w' );
		fwrite($file, serialize($this->my_config) );
		fclose( $file );
	}

	
	private function load_default_config()
	{
	    include PICLENS_INC_PATH.'default_values.inc.php';
	    foreach ($piclens_default_values as $key => $value) 
		{
		    if (!isset($this->my_config[$key]))		$this->my_config[$key] = $value;
		}
	}
	
	function piclens_admin_menu($menu)
	{
	    array_push($menu,
	       array(
	            'NAME' => 'Cooliris-Piclens',
	            'URL' => get_admin_plugin_menu_link(PICLENS_ADMIN_PATH.'piclens_admin.php')
	        ) 
	    );
	    return $menu;
	}

	function piclenswall()
	{
	    global $page;
		// piclens active+ activation du mur
//		if ($this->my_config['piclens_active'] && $this->my_config['piclens_wall'])
		if ($this->my_config['piclens_wall'])
	    if (isset($page['body_id']) and $page['section'] == 'categories')
		        include_once(PICLENS_PATH.'piclenswall.php');	
	}

	function piclens_thumbnails()
	{
	  global $template, $page;
		// piclens active
		if (	isset($page['section'])
			and $this->my_config['piclens_active'])
		{
			// Pages speciales et configuration activee
			if ($this->my_config['piclens_wall_spec'])
			{
				// Page images recentes
				if (($page['section']) == 'recent_pics' && $this->my_config['piclens_wall_spec_recentpics'])
					$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/recent_pics';

				// Page categories recentes
				elseif (($page['section']) == 'recent_cats' && $this->my_config['piclens_wall_spec_recentcats'])
					$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/recent_cats';

				// Page plus vues
				elseif (($page['section']) == 'most_visited' && $this->my_config['piclens_wall_spec_mostvisited'])
					$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/most_visited';

					// mieux notees	
				else if ($page['section'] == 'best_rated' && $this->my_config['piclens_wall_spec_bestrated'])
					$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/best_rated';

					// favories	
				else if ($page['section'] == 'favorites' && $this->my_config['piclens_wall_spec_favorites'])
					$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/favorites';
			}
			// Remplacement de la navigation
			if ($this->my_config['piclens_wall_nav'])
			{
				// Page categories	
				if ($page['section'] == 'categories'
					and !empty($page['category'])
				    and !empty($page['items']))
				{
					// verification de presence de la categorie dans la liste parametree
					if (in_array($page['category']['id'], $this->my_config['piclens_wall_cat_nav_replace']))
					{
						$rssfeed = $page['root_path'].PICLENS_PATH.'piclens-rss.php?/category/';
						$rssfeed .= empty($page['category']['permalink']) ? $page['category']['id'] : $page['category']['permalink'];
					}
				}
			}
		}

		if (isset($rssfeed))
		{
			$color = $this->my_config['piclens_wall_color'];
			$height = $this->my_config['piclens_wall_height'];
			$showfullscreen =  ($this->my_config['piclens_wall_showfullscreen'] ? "true" : "false");
			$showembed = ($this->my_config['piclens_wall_showembed'] ? "true" : "false");
			$showsearch = ($this->my_config['piclens_wall_showsearch'] ? "true" : "false");
			$template->assign('THUMBNAILS', 
				'<object id="o" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" 
					width="100%" height="'.$this->my_config['piclens_wall_height'].'" >
						<param name="movie" value="http://apps.cooliris.com/embed/cooliris.swf?feed='.$rssfeed.'&amp;style='.$color.'&amp;showEmbed='.$showembed.'&amp;showFullScreen='.$showfullscreen.'&amp;showSearch='.$showsearch.'" />
						<param name="allowFullScreen" value="'.$showfullscreen.'" />
						<param name="showEmbed" value="'.$showembed.'" />
						<param name="showSearch" value="'.$showsearch.'" />
						<param name="allowScriptAccess" value="always" />'
						.($this->my_config['piclens_wall_transparent']  
							?	'<param name="wmode" value="transparent" />
								<embed WMODE="transparent"' 
							: 	'<embed ')
						.'type="application/x-shockwave-flash" src="http://apps.cooliris.com/embed/cooliris.swf?feed='.$rssfeed.'&amp;style='.$color.'&amp;showEmbed='.$showembed.'&amp;showFullScreen='.$showfullscreen.'&amp;showSearch='.$showsearch.'" width="100%" height="'.$height.'" showEmbed="'.$showembed.'" showSearch="'.$showsearch.'" allowFullScreen="'.$showfullscreen.'" allowScriptAccess="always" />
				</object>'); 

		// Suppression de la barre de navigation
			$template->clear_assign('NAV_BAR');
			// Suppression de la barre de navigation categories (cas de l'affichage des categories recentes)
			if (($page['section']) == 'recent_cats')
				$template->clear_assign('CATEGORIES');
		}
	}
	

	
}

?>
